// Generated by CoffeeScript 2.3.0
(function() {
  var debug, default_internal_music, default_internal_ringback, pkg, tones;

  pkg = require('../../../package.json');

  this.name = `${pkg.name}:middleware:client:ingress:centrex-CH`;

  debug = (require('tangible'))(this.name);

  tones = require('../tones');

  default_internal_ringback = tones.ch.ringback;

  default_internal_music = tones.loop(tones.ch.waiting);

  this.include = async function() {
    var base, ref, ref1, ref2;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'ingress') {
      return;
    }
    if (this.session.dialplan !== 'centrex') {
      return;
    }
    if (this.session.country !== 'ch') {
      return;
    }
    // Add the outside line prefix so that the call can be placed directly.
    // Note: since we might also come here because we are routing an internal call, skip if the source doesn't need translation.
    if ((base = this.session).centrex_external_line_prefix == null) {
      base.centrex_external_line_prefix = '9';
    }
    await this.export({
      sip_invite_domain: this.session.number_domain
    });
    if (this.session.centrex_internal) {
      // await @export alert_info: 'info=centrex-internal'
      await this.export({
        alert_info: '<http://127.0.0.1/Bellcore-dr2>'
      });
    } else {
      if (this.session.ccnq_from_e164 != null) {
        this.source = `+${this.session.ccnq_from_e164}`;
      } else {
        if (this.source[0] === '0') {
          this.source = `${this.session.centrex_external_line_prefix}${this.source}`;
        }
      }
    }
    // Also force a normal ringback and no muzak on internal calls.
    if (this.session.centrex_internal) {
      this.session.ringback = (ref1 = this.cfg.internal_ringback) != null ? ref1 : default_internal_ringback;
      return this.session.music = (ref2 = this.cfg.internal_music) != null ? ref2 : default_internal_music;
    }
  };

}).call(this);
