// Generated by CoffeeScript 2.3.0
(function() {
  var debug, pkg;

  pkg = require('../../../package.json');

  this.name = `${pkg.name}:middleware:client:ingress:national-CH`;

  debug = (require('tangible'))(this.name);

  this.include = function() {
    var $, ref;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'ingress') {
      return;
    }
    if (this.session.dialplan !== 'e164') {
      return;
    }
    debug('Ready', {
      destination: this.destination,
      source: this.source
    });
    switch (false) {
      // Only route Fixed Network Services per Numbering Plan for International Carriers http://www.bakom.admin.ch/themen/telekom/00479/00604/index.html?lang=en
      // Rewrite destination
      // ===================

      // * session.ccnq_to_e164 (string) The original destination number (in E.164-sans-plus format) before translation to a national number.
      // * session.country (string) Two-letter name of the country in which a national number must be interpreted. Typically used when `session.dialplan` equals `national`.
      case !($ = this.destination.match(/^41((?:21|22|24|26|27|31|32|33|34|41|43|44|51|52|55|56|58|61|62|71|81|91)[0-9]+)$/)):
        this.session.ccnq_to_e164 = this.destination;
        this.destination = `0${$[1]}`;
        this.session.country = 'ch';
        break;
      default:
        return;
    }
    switch (false) {
      // from: national number
      // Rewrite source
      // ==============

      // * session.ccnq_from_e164 (string) The original calling number (in E.164-sans-plus format) before translation to a national number.
      // Destination _must_ be a Swiss (fixed) number.
      // Otherwise let it be parsed by another module.
      case !($ = this.source.match(/^41([0-9]+)$/)):
        this.session.ccnq_from_e164 = this.source;
        this.source = `0${$[1]}`;
        break;
      // from: international number
      case !($ = this.source.match(/^([1-9][0-9]+)$/)):
        this.session.ccnq_from_e164 = this.source;
        this.source = `00${$[1]}`;
        break;
      // from: anonymous
      case this.source !== 'anonymous':
        debug('Source is anonymous');
        break;
      default:
        debug('Invalid source', this.source);
        return this.respond('484 Invalid source');
    }
    // Update the dialplan
    // ===================

    // * session.dialplan (string) The dialplan in which a number (source, destination) must be interpreted.
    this.session.dialplan = 'national';
    debug('OK', {
      source: this.source,
      destination: this.destination,
      diaplan: this.session.dialplan,
      country: this.session.country
    });
  };

}).call(this);
